; CONSOLE #
include win64a.inc

MAXSCREENX = 43
MAXSCREENY = 8
.code
WinMain proc
local ConsoleWindow:SMALL_RECT;  sizeof=0x8, align=0x2
local cci:CONSOLE_CURSOR_INFO;	 sizeof=0x8, align=0x4
local ExitCode:DWORD; 
local pi:PROCESS_INFORMATION;	 sizeof=0x18, align=0x8
local cif:STARTUPINFO;	         sizeof=0x68, align=0x8
local MOUSE_KEY:INPUT_RECORD; sizeof=0x14, align=0x4
local Result:QWORD

	invoke	SetConsoleTitle,&Str2
	invoke	system,&Str5
	invoke	GetStdHandle,STD_INPUT_HANDLE
	mov	hIn,rax
	invoke	GetStdHandle,STD_OUTPUT_HANDLE
	mov	hOut,rax
	invoke	WriteConsole,eax,&Str1,sizeof Str1,&Result,0
@@:	invoke	ReadConsoleInput,hIn,&MOUSE_KEY,TRUE,&Result
	cmp	MOUSE_KEY.EventType,KEY_EVENT
	jnz	@b
	cmp	MOUSE_KEY.KeyEvent.bKeyDown,FALSE
	jnz	@b
	cmp	MOUSE_KEY.KeyEvent.wVirtualKeyCode,VK_ESCAPE
	jnz	@b
	invoke	FreeConsole
;----------------------------------------------------------------
	mov	cif.cb,sizeof STARTUPINFO;rbp-94h
	mov	cif.lpReserved,rbx;0
	mov	cif.lpDesktop,rbx;0
	mov	eax,offset Str3
	mov	cif.lpTitle,rax ;Display name for the title bar of the new console's window
	mov	cif.dwFlags,STARTF_USEPOSITION or STARTF_USESIZE or \
	STARTF_USECOUNTCHARS or STARTF_USEFILLATTRIBUTE or \
	STARTF_USESHOWWINDOW
	mov	cif.dwFillAttribute,BACKGROUND_BLUE+FOREGROUND_BLUE+\
	FOREGROUND_GREEN+FOREGROUND_RED;Text and background color attributes of the new console's screen buffer
	mov	cif.dwX,200	; left edge Location of the new console window, in screen pixel coordinates
	mov	cif.dwY,200	; upper edge
	mov	cif.dwXSize,400	; width 400/8=50
	mov	cif.dwYSize,96	; height 96/12=8
	mov	cif.dwXCountChars,50	; width Size of the new console's screen buffer, in character cells
	mov	cif.dwYCountChars,8	; height
	mov	cif.wShowWindow,SW_SHOW
	mov	cif.cbReserved2,0
	mov	cif.lpReserved2,rbx
	invoke	CreateProcess,&Str4,0,0,0,0,CREATE_NEW_CONSOLE,0,0,&cif,&pi
@@:	invoke	GetExitCodeProcess,pi.hProcess,&ExitCode
	cmp	ExitCode,STILL_ACTIVE
	jz	@b
	invoke	TerminateProcess,pi.hProcess,0
	invoke	CloseHandle,pi.hThread
	invoke	CloseHandle,pi.hProcess
	invoke	FreeConsole
;--------------------------------------------------
	invoke	AllocConsole
	invoke	GetLargestConsoleWindowSize,hOut
	lea	r8d,ConsoleWindow
	mov	dword ptr [r8],0;ConsoleWindow.Left = 0 ConsoleWindow.Top = 0	
	sub	ax,MAXSCREENX
	sbb	edx,edx
	and	ax,dx
	add	ax,MAXSCREENX-1
	mov	[r8+SMALL_RECT.Right],ax
	shr	eax,16
	sub	eax,MAXSCREENY
	sbb	edx,edx
	and	eax,edx
	add	eax,MAXSCREENY-1
	mov	[r8+SMALL_RECT.Bottom],ax	
	invoke	SetConsoleWindowInfo,hOut,TRUE
	invoke	SetConsoleScreenBufferSize,hOut,MAXSCREENY*10000h+MAXSCREENX
	invoke	SetConsoleTitle,&Str6
	invoke	WriteConsole,hOut,&Str7,sizeof Str7,&Result,0
	invoke	GetConsoleCursorInfo,hOut,&cci
	mov	cci.bVisible,FALSE
        invoke	SetConsoleCursorInfo,hOut,&cci
@@:     invoke	ReadConsoleInput,hIn,&MOUSE_KEY,TRUE,&Result
	cmp	MOUSE_KEY.EventType,KEY_EVENT
	jnz	@b
        cmp	MOUSE_KEY.KeyEvent.bKeyDown,FALSE
	jnz	@b
        cmp	MOUSE_KEY.KeyEvent.wVirtualKeyCode,VK_ESCAPE
	jnz	@b
	invoke	CloseHandle,hIn
	invoke	CloseHandle,hOut
	invoke	FreeConsole	
	invoke	RtlExitUserProcess,NULL
WinMain endp
hOut	dq ?
hIn	dq ?
Str1 db 'This console was created by system at start of the console application.',10,\
'For continue press the Esc key'
Str2 db 'First console',0
Str3 db 'Second console',0
Str4 db '23.exe',0
Str5 db 'cls',0
Str6 db 'Third console',0
Str7 db 'This console was created by the AllocConsole function.',10,\
'For an exit from the program press the Esc key'
end